chiark / gitweb /
dot/bash_profile: Don't change directory if running under schroot.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
ce178f96
MW
5###--------------------------------------------------------------------------
6### Basic setup.
7
f617db13
MW
8umask 002
9
4aa875e9 10sub=
f617db13
MW
11mkdir -p $HOME$sub
12
82c688c7 13: ${REPO=http://ftp.distorted.org.uk/pub/mdw/profile}
f617db13
MW
14
15export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
16
ce178f96
MW
17###--------------------------------------------------------------------------
18### Sort out command line.
19
f617db13
MW
20xstuff= false=
21while [ $# -gt 0 ]; do
22 case "$1" in
23 -x) xstuff=t;;
24 -n) false=false;;
25 --) shift; break;;
26 -*) echo >&2 "$0: bad option"; exit 1;;
27 *) break;;
28 esac
29 shift
30done
31
ce178f96
MW
32###--------------------------------------------------------------------------
33### Environment autoconfiguration.
34
35## Find out where I am
f617db13 36here=$(pwd)
f617db13 37
ce178f96 38## Suss out how to print things
f617db13
MW
39out=$(echo -n "foo"; echo "bar")
40if [ "$out" = "foobar" ]; then
41 echon="echo -n"
42 echoc=""
43else
44 echon="echo"
45 echoc='\c'
46fi
47
ce178f96 48## Find out how to fetch things over the net
f617db13
MW
49$echon "Finding URL fetcher:$echoc"
50if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
51 GETURL="curl -fs -o"
52 echo " curl."
53elif wget >/dev/null 2>&1 --version; then
54 GETURL="wget -q -O"
55 echo " wget."
56else
57 echo " failed!"
58 echo >&2 "$0: failed to find URL fetcher"
59 exit 1
60fi
61
ce178f96
MW
62###--------------------------------------------------------------------------
63### Create the necessary directories.
64
65echo "Creating directories..."
66for i in bin lib/emacs src; do
67 $echon " $i:$echoc"
68 if [ -d $HOME$sub/$i ]; then
69 echo " already exists."
70 else
71 mkdir -p $HOME$sub/$i
72 echo " done."
73 fi
74done
75echo " all done."
76
ce178f96
MW
77###--------------------------------------------------------------------------
78### Install some more complicated programs.
79
f617db13
MW
80echo "Installing packages..."
81systems="
285a1386
MW
82 mlib:crc-mktab
83 checkpath:tmpdir
f617db13
MW
84"
85[ "$xstuff" ] && systems="$systems
285a1386 86 xtoys:xatom
f617db13
MW
87"
88for system in $systems; do
89 set -- $(echo $system | tr : ' ')
285a1386 90 sys=$1 prog=$2
f617db13
MW
91 $echon " $sys:$echoc"
92 if $false $prog >/dev/null 2>&1 --version; then
93 echo " already installed."
94 else
95 ( set -e
96 $echon " downloading$echoc"
97 cd $HOME$sub/src
285a1386
MW
98 rm -rf $sys.tar.gz $sys-$ver
99 $GETURL $sys.tar.gz $REPO/$sys.tar.gz
f617db13 100 $echon " unpacking$echoc"
285a1386
MW
101 dir=$(gzip -cd $sys.tar.gz | tar tf - | head -1)
102 gzip -cd $sys.tar.gz | tar xf -
f617db13 103 $echon " configuring$echoc"
285a1386 104 cd $dir
f617db13
MW
105 mkdir build
106 cd build
188ebb31
MW
107 ../configure \
108 --prefix=$HOME$sub \
109 PKG_CONFIG_PATH=$HOME$sub/lib/pkgconfig \
110 >>buildlog 2>&1
f617db13
MW
111 $echon " building$echoc"
112 make >>buildlog 2>&1
113 $echon " installing$echoc"
114 make install >>buildlog 2>&1
115 echo " done."
116 )
117 fi
118done
852cd5fb 119echo " all done."
f617db13 120
ce178f96
MW
121###--------------------------------------------------------------------------
122### Install global configuration.
123
f141fe0f
MW
124echo -n "Installing dotfile configuration:"
125if [ -f $HOME$sub/.mdw.conf ]; then
126 echo " already installed."
127else
128 cp mdw.conf $HOME$sub/.mdw.conf
129 echo " done."
130fi
131
ce178f96 132## Symlink the various dotfiles into place
852cd5fb 133dotfiles="
be7dba95 134 bash_profile bash_logout bashrc inputrc bash_completion
54896c4f 135 emacs emacs-calc vm gnus.el ercrc.el
4fc3203b 136 vimrc mg zile lesskey
30169591 137 ditz-config
ce39049e 138 mailrc signature muttrc
ce178f96 139 cgrc tigrc
e7d23024 140 gdbinit
8a7e906d 141 guile
1d89ce86 142 rcrc
5d25e440 143 toprc
a6a6806a 144 mc-ini:.mc/ini mc-panels.ini:.mc/panels.ini
f56d38cd 145 pulse-daemon.conf:.pulse/daemon.conf
cbffcf2b 146 aspell.conf
78719982 147 tclshrc:.tclshrc tclshrc:.wishrc
ccaac00b
MW
148 lisp-init.lisp:.cmucl-init.lisp
149 lisp-init.lisp:.sbclrc
150 lisp-init.lisp:.clisprc.lisp
f6335a0c 151 lisp-init.lisp:.eclrc
b5bf3445 152 swank.lisp
5a91acc5 153 mdw-build.conf:.config/mdw-build.conf
3ec64a11 154 w3m-config:.w3m/config elinks.conf:.elinks/elinks.conf
2425eca9 155 dircolors colordiffrc screenrc cvsrc indent.pro"
739bccbf 156[ "$xstuff" ] && dotfiles="$dotfiles
f7cb5c84 157 xinitrc xsession xmodmap vncrc vncsession
5e23020b 158 fonts.conf
e517857c 159 stalonetrayrc
1c6b19d4 160 putty-defaults:.putty/sessions/Default%20Settings
2e60c7f3 161 mdw.session:.config/gnome-session/sessions/mdw.session
7cfa1f1a 162 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
739bccbf 163 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 164 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
f4e43257 165 e16-bindings:.e16/bindings.cfg"
f617db13
MW
166echo "Installing dotfiles..."
167for d in $dotfiles; do
739bccbf
MW
168 target=.$d
169 case $d in
170 *:*) target=${d#*:} d=${d%%:*};;
171 esac
172 ft=$HOME$sub/$target
173 dir=${ft%/*}
174 mkdir -p $dir
99063107 175 ln -s $here/dot/$d $ft.new
739bccbf
MW
176 mv $ft.new $ft
177 echo " $target"
f617db13 178done
852cd5fb 179echo " all done."
f617db13 180
f7cb5c84
MW
181## CPP-hack files which need it.
182cppfiles=""
183[ "$xstuff" ] && cppfiles="$cppfiles
184 Xdefaults"
185echo "Hacking files with C preprocessor..."
186for c in $cppfiles; do
187 target=.$c
188 case $c in
189 *:*) target=${c#*:} c=${c%%:*};;
190 esac
191 ft=$HOME$sub/$target
192 dir=${ft%/*}
193 mkdir -p $dir
18312fb5 194 cpp -P dot/$c -o $ft.new
f7cb5c84
MW
195 mv $ft.new $ft
196 echo " $target"
197done
198echo " all done."
199
403dc178
MW
200## Substitute things which need substituting.
201dotfilessubst="
202 gitconfig
8508a859 203 mykermrc
403dc178
MW
204 pulse-default.pa.in:.pulse/default.pa"
205echo "Installing dotfiles with substitutions..."
206for d in $dotfilessubst; do
207 case $d in
208 *:*) target=${d#*:} d=${d%%:*};;
209 *) target=.$d d=$d.in;;
210 esac
211 ft=$HOME$sub/$target
212 dir=${ft%/*}
213 mkdir -p $dir
214 sed "
2b5d4580
MW
2151i\\
216### generated by $here/setup; do not edit!\\
403dc178
MW
217
218/@home@/ s\a\a$HOME\ag
73165cde 219/@profile@/ s\a\a$here\ag
bf674ae1 220/@releasekey@/ s\a\a$(bin/mdw-conf releasekey 481334C2)\ag
403dc178
MW
221" dot/$d >$ft.new
222 mv $ft.new $ft
223 echo " $target"
224done
225echo " all done."
226
f4e43257 227## Symlink backgrounds.
960af1a5 228backgrounds="
5236501e 229 bsg-supper.jpg
9fe91389 230 harley-quinn.jpg
56c871ef 231 hypatia.jpg
7bdd0453 232 jue-peek.jpg
9f56284f 233 lilith.jpg
7bdd0453
MW
234 lovelace.jpg
235 medusa.jpg
236 noodly.jpg
237 rayne.jpg
238"
f4e43257
MW
239if [ "$xstuff" ]; then
240 echo "Installing backgrounds..."
241 for b in $backgrounds; do
242 for e in enlightenment e16; do
243 dir=$HOME$sub/.$e/backgrounds
244 t=$dir/$b
245 mkdir -p $dir
99063107 246 ln -s $here/bg/$b $t.new
f4e43257
MW
247 mv $t.new $t
248 done
249 echo " $b"
250 done
251 echo " all done."
252fi
253
ce178f96
MW
254###--------------------------------------------------------------------------
255### Install useful scripts included in this package.
256
e04c4857 257scripts="
547fb8af 258 mdw-editor
b20bfd83 259 mdw-pager
b056f5c4 260 mdw-conf
b94830d9 261 mdw-build mdw-sbuild mdw-sbuild-server
5f56828b 262 update-buildable-branch
c4e84cb1 263 emacsclient-hack
8e08f814 264 movemail-hack
aaa2d943 265 sendmail-hack
68b2e9e6 266 aspell-hack
285a1386
MW
267 emerge-hack
268 lesspipe.sh
6a5170a8 269 run-with-shell-env
285a1386 270 start-ssh-agent
6a5170a8 271 start-ssh-pageant
4cdeb0d0 272 svnwrap
73bb9001 273 guest-console
4cdeb0d0 274 hyperspec"
8e08f814 275[ "$xstuff" ] && scripts="$scripts
3bdada49 276 xinitcmd
34a5ea4e 277 un-backslashify-selection
c02999e8 278 lock-screen
b7743290 279 xpra-start-xdummy
8e08f814 280 xshutdown"
e04c4857
MW
281echo "Installing scripts..."
282mkdir -p $HOME$sub/bin
283for s in $scripts; do
284 ft=$HOME$sub/bin/$s
99063107 285 ln -s $here/bin/$s $ft.new
e04c4857
MW
286 mv $ft.new $ft
287 echo " $s"
288done
289echo " all done."
290
4d7d040b
MW
291hacks="
292 ssh:ssh"
293echo "Installing hacks..."
294for h in $hacks; do
295 d=${h%%:*} h=${h#*:}
296 ft=$HOME$sub/bin/hacks/$d
297 mkdir -p $ft
298 ln -s $here/hacks/$h $ft/$h.new
299 mv $ft/$h.new $ft/$h
300 echo " $d:$h"
301done
302echo " all done."
303
ce178f96
MW
304###--------------------------------------------------------------------------
305### Set up the Emacs config.
306
65ff0e8c
MW
307$echon "Finding a suitable emacs:$echoc"
308emacs=no
5fe24792 309for i in emacs22 emacs23 emacs21 emacs; do
65ff0e8c
MW
310 if type -p >/dev/null $i; then
311 emacs=$i
312 break
313 fi
314done
315if [ $emacs = no ]; then
316 echo " failed."
317 emacs=:
318else
319 echo " $emacs."
320fi
321
f617db13 322echo "Installing Emacs packages..."
400223a1
MW
323emacspkg="
324 make-regexp
a1293ade 325 ew-hols
a3bdb4d9 326 mdw-gnus-patch
1778b496 327 git git-blame vc-git stgit
c6fe19d5 328 mdw-multiple-cursors
400223a1
MW
329 quilt"
330for elib in $emacspkg; do
f617db13 331 $echon " $elib:$echoc"
65ff0e8c 332 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692 333 (progn
852cd5fb
MW
334 (setq load-path (nconc load-path (list "~/lib/emacs")))
335 (kill-emacs (condition-case nil
336 (progn (load-library "'"$elib"'") 0)
20eb0692 337 (error 1))))'; then
f617db13
MW
338 echo " already installed."
339 else
99063107
MW
340 if [ -f el/$elib.el ]; then
341 cp el/$elib.el $HOME$sub/lib/emacs/$elib.el
a3bdb4d9
MW
342 else
343 $echon " downloading$echoc"
344 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
345 fi
f617db13
MW
346 $echon " compiling$echoc"
347 (cd $HOME$sub/lib/emacs;
65ff0e8c 348 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 349 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
350 echo " done."
351 fi
352done
852cd5fb 353echo " all done."
f617db13
MW
354
355$echon "Setting up Emacs configuration:$echoc"
356$echon " linking$echoc"
99063107 357for f in dot-emacs.el Makefile; do
f617db13 358 set -- $(echo $link | tr : ' ')
99063107
MW
359 ln -s $here/el/$f $HOME$sub/lib/emacs/$f.new
360 mv $HOME$sub/lib/emacs/$f.new $HOME$sub/lib/emacs/$f
f617db13
MW
361done
362$echon " compiling$echoc"
c39d1139 363{ cd $HOME$sub/lib/emacs && make EMACS=$emacs; } >/dev/null 2>&1
f617db13 364echo " done."
ce178f96
MW
365
366###----- That's all, folks --------------------------------------------------